#include "CSimpleArrays.h"
#include "Common.h"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CSimpleArrays

CSimpleArrays::CSimpleArrays(unsigned int ArraySize)
	:m_hGPUResult(NULL), m_hA(NULL), m_hB(NULL), m_hC(NULL),
	m_dA(NULL), m_dB(NULL), m_dC(NULL),
	m_ArraySize(ArraySize)
{
}

CSimpleArrays::~CSimpleArrays()
{
}

bool CSimpleArrays::InitResources(cl_device_id Device, cl_context Context)
{
	//CPU resources
	m_hA = new int[m_ArraySize];
	m_hB = new int[m_ArraySize];
	m_hC = new int[m_ArraySize];
	m_hGPUResult = new int[m_ArraySize];
	
	//fill A and B with random integers
	for(unsigned int i = 0; i < m_ArraySize; i++)
	{
		m_hA[i] = rand() % 1024;
		m_hB[i] = rand() & 1024;
	}
	
	//device resources

	/////////////////////////////////////////
	// Sect. 4.5

	//TO DO: allocate arrays!

	/////////////////////////////////////////
	// Sect. 4.6.
	
	//TO DO: load and compile kernels

	//TO DO: bind kernel arguments

	return true;
}

void CSimpleArrays::ReleaseResources()
{
	//CPU resources
	SAFE_DELETE_ARRAY(m_hA);
	SAFE_DELETE_ARRAY(m_hB);
	SAFE_DELETE_ARRAY(m_hC);
	SAFE_DELETE_ARRAY(m_hGPUResult);

	/////////////////////////////////////////////////
	// Sect. 4.5., 4.6.	

	//TO DO: free resources on the GPU
}

void CSimpleArrays::ComputeCPU()
{
	for(unsigned int i = 0; i < m_ArraySize; i++)
	{
		m_hC[i] = m_hA[i] + m_hB[m_ArraySize - i - 1];
	}
}

void CSimpleArrays::ComputeGPU(cl_context Context, cl_command_queue CommandQueue, size_t LocalWorkSize[3])
{
	/////////////////////////////////////////////////
	// Sect. 4.5

	//copy input data to the GPU buffers

	/////////////////////////////////////////
	// Sect. 4.6.
	
	//execute the kernel: one thread for each element!

			// Sect. 4.7.: rewrite the kernel call to use our RunKernelNTimes()
			//				utility function to measure execution time.
			//				Also print out the execution time.

	//read back results synchronously.
	//This command has to be blocking, since we need the data
}

bool CSimpleArrays::ValidateResults()
{
	//the results are valid only if they match the CPU reference exactly

	//NOTE: this simple comparison is only eligible, if we used fixed-point arithmetics (i.e. integers)
	//on the CPU and the GPU as well. When using floating-point arithmetics, it might happen that the same
	//operations result in different bit patterns due to precision and execution ordering problems.
	return (memcmp(m_hC, m_hGPUResult, m_ArraySize * sizeof(float)) == 0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
